local this_thread = love.thread.getThread()
require "love.image"


local width = this_thread:demand("width")
local height = this_thread:demand("height")
local depth = 128
local x0 = this_thread:demand("x0")
local y0 = this_thread:demand("y0")
local x1 = this_thread:demand("x1")
local y1 = this_thread:demand("y1")
local dx = x1 - x0
local dy = y1 - y0

local palette = {}
for i=0, depth do
	local r = math.floor(i / depth * 1024)
	if r > 255 then
		r = 255
	end
	local g = math.floor((i - depth / 3) / depth * 1024)
	if g > 255 then
		g = 255
	end
	if g < 0 then
		g = 0
	end
	local b = math.floor((i - depth / 3 * 2) / depth * 1024)
	if b > 255 then
		b = 255
	end
	if b < 0 then
		b = 0
	end
	palette[i] = {R = r, G = g, B = b}
end
palette[depth-1] = {R = 0, G = 0, B = 0}
local image = love.image.newImageData(width, height)
while true do
	local x0 = this_thread:demand("x0")
	local y0 = this_thread:demand("y0")
	local x1 = this_thread:demand("x1")
	local y1 = this_thread:demand("y1")
	for y=0, height-1 do
		for x=0, width-1 do
			local r = 0
			local n = 0
			local b = x / width * dx + x0
			local e = y / height * dy + y0
			local i = 0
			while i < depth-1 and r * r < 4 do
				local d = r
				r = r * r - n * n + b
				n = 2 * d * n + e
				i = i + 1
			end
			local p = palette[i]
			image:setPixel(x, y, p.R, p.G, p.B, 255)
		end
		this_thread:send("progress", math.floor(100/(height-1)*(y+1)))
	end
	this_thread:send("image", image)
end