function love.load()
	x0 = -0.65
	y0 = -0.7
	x1 = -0.5
	y1 = -0.6
	gen_thread = love.thread.newThread("genimage", "genimage.lua")
	gen_thread:start()
	width = love.graphics.getWidth()
	local height = love.graphics.getHeight()
	gen_thread:send("width", width)
	gen_thread:send("height", height)
	font = love.graphics.newFont(16)
	love.graphics.setFont(font)
end

function love.keypressed(k)
	if k == 'up' then
		x0 = x0 + 0.05
		x1 = x1 - 0.05
	elseif k == 'down' then
		x0 = x0 - 0.05
		x1 = x1 + 0.05
	end
	if k == 'right' then
		y1 = y1 + 0.05
		y0 = y0 + 0.05
	elseif k == 'left' then
		y1 = y1 - 0.05
		y0 = y0 - 0.05
	end
end

function love.update(dt)
	gen_thread:send("x0", x0)
	gen_thread:send("y0", y0)
	gen_thread:send("x1", x1)
	gen_thread:send("y1", y1)
	imagedata = gen_thread:receive("image")
	progress = gen_thread:peek("progress")
	if imagedata then
		image = love.graphics.newImage(imagedata)
	end
end

function love.draw()
	if image then
		love.graphics.draw(image, 0, 0)
	end
	local progress_string = (progress or 0) .. "%"
	love.graphics.print(progress_string, 0, 0)
end